#-------------------------------------------------
#
# Project created by QtCreator 2018-02-10T20:30:04
#
#-------------------------------------------------

    VERSION = 0.0.1

CONFIG += c++17
QMAKE_CXXFLAGS = -Wall -Werror -Wextra -Wpedantic -Wconversion -std=c++17 -O2 -g
QT += core gui multimedia widgets quickwidgets

# Potato22 is the best vector artist, you can't change my mind.
# The icon is precious!
RC_FILE += add_ico.rc

TARGET   = QuestWizard
TEMPLATE = app

DEFINES += QT_DEPRECATED_WARNINGS

SOURCES += main.cpp \
    game.cpp \
    features/qw_abstractdialoguemanager.cpp \
    features/qw_dialoguefactory.cpp \
    features/qw_textdialoguemanager.cpp \
    features/qw_widgetdialoguemanager.cpp \
    features/qw_eventfactory.cpp \
    features/qw_inventorymanager.cpp \
    features/qw_levelbuilder.cpp \
    features/qw_soundplayer.cpp \
    features/qw_statemachine.cpp \
    qw_globalmetadata.cpp \
    \
    models/events/qw_abstractevent.cpp \
    models/events/qw_abstractinventoryevent.cpp \
    models/events/qw_abstractlevelevent.cpp \
    models/events/qw_abstractsceneevent.cpp \
    models/events/qw_abstractsoundevent.cpp \
    models/events/qw_changelocationevent.cpp \
    models/events/qw_changetriggerpropertiesevent.cpp \
    models/events/qw_deletefrominventoryevent.cpp \
    models/events/qw_endlevelevent.cpp \
    models/events/qw_newgameevent.cpp \
    models/events/qw_pickupitemevent.cpp \
    models/events/qw_playmusicevent.cpp \
    models/events/qw_playsoundevent.cpp \
    models/events/qw_quitgameevent.cpp \
    models/events/qw_startdialogueevent.cpp \
    models/events/qw_addtriggerevent.cpp \
    models/events/qw_removetriggerevent.cpp \
    models/events/qw_switcheventsevent.cpp \
    models/dialogues/qw_abstractgamedialogue.cpp \
    models/dialogues/qw_textdialogue.cpp \
    models/dialogues/qw_widgetdialogue.cpp \
    models/qw_tagholder.cpp \
    models/qw_trigger.cpp \
    models/qw_location.cpp \
    \
    view/controls/pushbuttonsound.cpp \
    view/controls/qw_abstractscenecontrol.cpp \
    view/controls/scenedialoguepanel.cpp \
    view/controls/sceneinventorypanel.cpp \
    \
    view/qw_scene.cpp \
    view/qw_view.cpp

HEADERS  += \
    game.h \
    features/qw_abstractdialoguemanager.h \
    features/gamefeatures.h \
    features/qw_dialoguefactory.h \
    features/qw_textdialoguemanager.h \
    features/qw_widgetdialoguemanager.h \
    features/qw_eventfactory.h \
    features/qw_inventorymanager.h \
    features/qw_levelbuilder.h \
    features/qw_soundplayer.h \
    features/qw_statemachine.h \
    qw_globalmetadata.h \
    \
    models/events/qw_abstractevent.h \
    models/events/qw_abstractinventoryevent.h \
    models/events/qw_abstractlevelevent.h \
    models/events/qw_abstractsceneevent.h \
    models/events/qw_abstractsoundevent.h \
    models/events/qw_changelocationevent.h \
    models/events/qw_changetriggerpropertiesevent.h \
    models/events/qw_deletefrominventoryevent.h \
    models/events/qw_endlevelevent.h \
    models/events/qw_newgameevent.h \
    models/events/qw_pickupitemevent.h \
    models/events/qw_playmusicevent.h \
    models/events/qw_playsoundevent.h \
    models/events/qw_quitgameevent.h \
    models/events/qw_startdialogueevent.h \
    models/events/qw_addtriggerevent.h \
    models/events/qw_removetriggerevent.h \
    models/events/qw_switcheventsevent.h \
    models/dialogues/qw_abstractgamedialogue.h \
    models/dialogues/qw_textdialogue.h \
    models/dialogues/qw_widgetdialogue.h \
    models/qw_tagholder.h \
    models/qw_trigger.h \
    models/qw_location.h \
    \
    view/controls/pushbuttonsound.h \
    view/controls/qw_abstractscenecontrol.h \
    view/controls/scenedialoguepanel.h \
    view/controls/sceneinventorypanel.h \
    \
    view/qw_scene.h \
    view/qw_view.h


RESOURCES += \
    application.qrc

DISTFILES += \
    qml/test.qml
