#ifndef QWDIALOGUEFACTORY_H
#define QWDIALOGUEFACTORY_H

#include "models/dialogues/qw_textdialogue.h"
#include "models/dialogues/qw_widgetdialogue.h"

/* QWDialogueFactory
 * Creates game dialogues of all kinds! */

class QWLevelBuilder;

class QWDialogueFactory final
{
private:
    QWLevelBuilder *builder;

public:
    explicit QWDialogueFactory(QWLevelBuilder *b);

    std::shared_ptr<QWTextDialogue> createTextDialogue(const QJsonObject &json_object);
    std::shared_ptr<QWWidgetDialogue> createWidgetDialogue(const QJsonObject &json_object);
};

#endif // QWDIALOGUEFACTORY_H
